/**********************************************************************
$Id: conffile.c,v 1.7 2002/08/11 10:39:17 bu Exp $

Copyright 2001-2002, Bulent Yilmaz

Part of Microbrew MicroSieve
USENET SPAM filter

http://www.microbrew.org/products/usieve.html


MicroSieve is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

MicroSieve is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MicroSieve; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

**********************************************************************/
#include "conffile.h"

/* Local only function */
char *trim(char *mystr) {

    char *myptr;

    if((myptr = strchr(mystr, '\n')) != NULL) {
        *myptr=0;
    }
    return mystr;
}

long int getmaxartsize() {
    FILE *conffile;
    char value[256];
    long int retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
    	        if(strstr(value, "MaxArticleSize")) {
    	            if((retval=(atol(strchr(&value[0], ' '))))>0) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for MaxArticleSize in " CONF_FILE);
                }
    	    } 
    	}
    	cflog("MaxArticleSize is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default MaxArticleSize of 1048576");
    return 1048576;
}

long int gethistorysize() {
    FILE *conffile;
    char value[256];
    long int retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "ArticleHistorySize")) {
    	            if((retval=(atol(strchr(&value[0], ' '))))>0) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for ArticleHistorySize in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("ArticleHistorySize is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default ArticleHistorySize of 1048575");
    return 1048575;
}

long int getstatsinterval() {
    FILE *conffile;
    char value[256];
    long int retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "StatsInterval")) {
    	            if((retval=(atol(strchr(&value[0], ' '))))>0) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for StatsInterval in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("StatsInterval is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default StatsInterval of 300 seconds");
    return 300;
}

int getmaxcrossposts() {
    FILE *conffile;
    char value[256];
    int retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "MaxCrossPosts")) {
    	            if((retval=(atol(strchr(&value[0], ' '))))>0) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for MaxCrossPosts in " CONF_FILE);
    	        } 
            }
    	}
    	cflog("MaxCrossPosts is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default MaxCrossPosts of 5");
    return 5;
}


char *getlogfilename() {
    FILE *conffile;
    char value[256];
    char *retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "LogFile")) {
    	            if( (retval = (strdup( trim(strchr(&value[0], ' ') + 1) )) )!=0 ) {
    	                fclose(conffile);
    	                return retval;
    	            } else puts("Could not get meaningful value for LogFile in " CONF_FILE);
    	        }
            } 
    	}
    	puts("LogFile is not defined in " CONF_FILE);
    	fclose(conffile);
    } else puts("Could not open configuration file: " CONF_FILE);
    
    puts("Using default LogFile name of " DEFAULT_LOGFILE);
    return strdup(DEFAULT_LOGFILE);
}

char *getpidfilename() {
    FILE *conffile;
    char value[256];
    char *retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "PIDFile")) {
    	            if( (retval = ((strdup( trim(strchr(&value[0], ' ')+1)) )) )!=0 ) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for PIDFile in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("PIDFile is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default PIDFile name of " DEFAULT_PIDFILE);
    return strdup(DEFAULT_PIDFILE);
}

char *getstatsfilename() {
    FILE *conffile;
    char value[256];
    char *retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "StatsFile")) {
    	            if( (retval = ((strdup( trim(strchr(&value[0], ' ')+1)) )) )!=0 ) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for StatsFile in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("StatsFile is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default StatsFile name of " DEFAULT_STATSFILE);
    return strdup(DEFAULT_STATSFILE);
}

char *getarticlelogname() {
    FILE *conffile;
    char value[256];
    char *retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "ArticleLog")) {
    	            if( (retval = ((strdup( trim(strchr(&value[0], ' ')+1)) )) )!=0 ) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for ArticleLog in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("ArticleLog is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default ArticleLog name of " DEFAULT_ARTICLELOG);
    return strdup(DEFAULT_ARTICLELOG);
}

char *gethistorylogname() {
    FILE *conffile;
    char value[256];
    char *retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "HistoryLog")) {
    	            if( (retval = ((strdup( trim(strchr(&value[0], ' ')+1)) )) )!=0 ) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for HistoryLog in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("HistoryLog is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Returning NULL for HistoryLog.");
    return NULL;
}

char *getautoacceptregex() {
    FILE *conffile;
    char value[256];
    char *retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "AutoAcceptRegex")) {
    	            if( (retval = ((strdup( trim(strchr(&value[0], ' ')+1)) )) )!=0 ) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for AutoAcceptRegex in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("AutoAcceptRegex is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default AutoAcceptRegex of " DEFAULT_AUTOACCEPTREGEX);
    return strdup(DEFAULT_AUTOACCEPTREGEX);
}

char *getblackholeregex() {
    FILE *conffile;
    char value[256];
    char *retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "BlackholeRegex")) {
    	            if( (retval = ((strdup( trim(strchr(&value[0], ' ')+1)) )) )!=0 ) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for BlackholeRegex in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("BlackholeRegex is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default AutoAcceptRegex of " DEFAULT_BLACKHOLEREGEX);
    return strdup(DEFAULT_BLACKHOLEREGEX);
}

char *getuserregexfilename() {
    FILE *conffile;
    char value[256];
    char *retval=0;
    
    conffile=fopen(CONF_FILE, "r");
    if(conffile) {
    	while(!feof(conffile)) {
    	    fgets(&value[0], 255, conffile);
            if(value[0]!='#') {
                if(strstr(value, "UserRegexFile")) {
    	            if( (retval = ((strdup( trim(strchr(&value[0], ' ')+1)) )) )!=0 ) {
    	                fclose(conffile);
    	                return retval;
    	            } else cflog("Could not get meaningful value for UserRegexFile in " CONF_FILE);
    	        }
            } 
    	}
    	cflog("UserRegexFile is not defined in " CONF_FILE);
    	fclose(conffile);
    } else cflog("Could not open configuration file: " CONF_FILE);
    
    cflog("Using default UserRegexFile name of " DEFAULT_USERREGEXFILE);
    return strdup(DEFAULT_USERREGEXFILE);
}
